/*
 * Created on 26-abr-2005
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 * 
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 * 
 *    or
 * 
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 * 
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.gui.styling;

import java.awt.BorderLayout;
import java.awt.Dimension;

import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

/**
 * @author FJP
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class SymbolSelector extends JPanel {

    private JList jListFav = null;  //  @jve:decl-index=0:visual-constraint="83,408"
    private JList jListSymbols = null;
    private JPanel jPanel = null;
    private JScrollPane jScrollPane = null;
    private JScrollPane jScrollPane1 = null;
    private JPanel jPanelPreview = null;
    private JPanel jPanelOptions = null;
    /**
     * This method initializes 
     * 
     */
    public SymbolSelector() {
    	super();
    	initialize();
        
        // TODO: Poner la funcin para que el modelo 
        // sea un directorio con smbolos, etc.
        DefaultListModel listModel = new DefaultListModel();
        listModel.addElement("D:/java/eclipse30/eclipse/workspace/FMap 03_SLD/docs/fill4.svg");
        listModel.addElement("D:/java/eclipse30/eclipse/workspace/FMap 03_SLD/docs/batikYin.svg");
        listModel.addElement("D:/java/eclipse30/eclipse/workspace/FMap 03_SLD/docs/gradients.svg");
        listModel.addElement("D:/java/eclipse30/eclipse/workspace/FMap 03_SLD/docs/batikYin.svg");
        listModel.addElement("D:/java/eclipse30/eclipse/workspace/FMap 03_SLD/docs/stroke1.svg");
        listModel.addElement("D:/java/eclipse30/eclipse/workspace/FMap 03_SLD/docs/fill3.svg");
        listModel.addElement("D:/java/eclipse30/eclipse/workspace/FMap 03_SLD/docs/fill1.svg");
        listModel.addElement("D:/java/eclipse30/eclipse/workspace/FMap 03_SLD/docs/fill2.svg");
        listModel.addElement("D:/java/eclipse30/eclipse/workspace/FMap 03_SLD/docs/batikLogo.svg");
        
        getJListSymbols().setModel(listModel);
        
        SLDListBoxCellRenderer renderer = new SLDListBoxCellRenderer();
        renderer.setPreferredSize(new Dimension(60, 50));
        getJListSymbols().setCellRenderer(renderer);
        // petList.setMaximumRowCount(3);
        


    }

    /**
     * This method initializes this
     * 
     */
    private void initialize() {
        this.setLayout(new BorderLayout());
        this.setSize(400, 221);
        this.add(getJScrollPane1(), java.awt.BorderLayout.CENTER);
        this.add(getJScrollPane(), java.awt.BorderLayout.WEST);
        this.add(getJPanel(), java.awt.BorderLayout.EAST);
    		
    }

    /**
     * This method initializes jList	
     * 	
     * @return javax.swing.JList	
     */    
    private JList getJListFav() {
    	if (jListFav == null) {
    		jListFav = new JList();
    		jListFav.setPreferredSize(new java.awt.Dimension(70,100));
    	}
    	return jListFav;
    }

    /**
     * This method initializes jList	
     * 	
     * @return javax.swing.JList	
     */    
    private JList getJListSymbols() {
    	if (jListSymbols == null) {
    		jListSymbols = new JList();
    		jListSymbols.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
            jListSymbols.setLayoutOrientation(JList.HORIZONTAL_WRAP);
            jListSymbols.setVisibleRowCount(-1);

            jListSymbols.addListSelectionListener(new javax.swing.event.ListSelectionListener() { 
            	public void valueChanged(javax.swing.event.ListSelectionEvent e) {    
            		System.out.println("valueChanged()"); // TODO Auto-generated Event stub valueChanged()
                    // TODO: Aqu hay que extraer el Paint, el Stroke
                    // o lo que necesitemos del svg para generar nuestro propio
                    // smbolo.
            	}
            });
    	}
    	return jListSymbols;
    }

    /**
     * This method initializes jPanel	
     * 	
     * @return javax.swing.JPanel	
     */    
    private JPanel getJPanel() {
    	if (jPanel == null) {
    		jPanel = new JPanel();
    		jPanel.setLayout(new BorderLayout());
    		jPanel.setPreferredSize(new java.awt.Dimension(100,10));
    		jPanel.add(getJPanelOptions(), java.awt.BorderLayout.CENTER);
    		jPanel.add(getJPanelPreview(), java.awt.BorderLayout.NORTH);
    	}
    	return jPanel;
    }

    /**
     * This method initializes jScrollPane	
     * 	
     * @return javax.swing.JScrollPane	
     */    
    private JScrollPane getJScrollPane() {
    	if (jScrollPane == null) {
    		jScrollPane = new JScrollPane();
    		jScrollPane.setPreferredSize(new java.awt.Dimension(80,130));
    		jScrollPane.setHorizontalScrollBarPolicy(javax.swing.JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
    		jScrollPane.setViewportView(getJListFav());
    	}
    	return jScrollPane;
    }

    /**
     * This method initializes jScrollPane1	
     * 	
     * @return javax.swing.JScrollPane	
     */    
    private JScrollPane getJScrollPane1() {
    	if (jScrollPane1 == null) {
    		jScrollPane1 = new JScrollPane();
    		jScrollPane1.setViewportView(getJListSymbols());
    	}
    	return jScrollPane1;
    }

    /**
     * This method initializes jPanel1	
     * 	
     * @return javax.swing.JPanel	
     */    
    private JPanel getJPanelPreview() {
    	if (jPanelPreview == null) {
    		jPanelPreview = new JPanel();
    		jPanelPreview.setPreferredSize(new java.awt.Dimension(80,70));
    		jPanelPreview.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
    	}
    	return jPanelPreview;
    }

    /**
     * This method initializes jPanel1	
     * 	
     * @return javax.swing.JPanel	
     */    
    private JPanel getJPanelOptions() {
    	if (jPanelOptions == null) {
    		jPanelOptions = new JPanel();
    	}
    	return jPanelOptions;
    }

}  //  @jve:decl-index=0:visual-constraint="10,10"
