package com.iver.cit.gvsig.project;

public abstract class AbstractDocumentContextMenuAction extends
		AbstractContextMenuAction {

	public void execute(Object item, Object[] selectedItems) {
		this.execute((ProjectElement) item,(ProjectElement[])selectedItems);

	}
	
	public boolean isVisible(Object item, Object[] selectedItems) {
		return this.isVisible((ProjectElement) item, (ProjectElement[]) selectedItems);
	}
	

	public boolean isEnabled(Object item, Object[] selectedItems) {
		return this.isEnabled((ProjectElement) item, (ProjectElement[]) selectedItems);
	}
	
	
	public abstract boolean isVisible(ProjectElement item, ProjectElement[] selectedItems);
	
	public abstract boolean isEnabled(ProjectElement item, ProjectElement[] selectedItems);
		
	public abstract void execute(ProjectElement item, ProjectElement[] selectedItems) ;
}
