package com.iver.cit.gvsig.fmap.layers.gml;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.net.URL;

import javax.xml.parsers.DocumentBuilderFactory;

import org.geotools.data.DefaultQuery;
import org.geotools.data.FeatureReader;
import org.geotools.data.Transaction;
import org.geotools.data.wfs.WFSDataStore;
import org.geotools.data.wfs.WFSDataStoreFactory;
import org.geotools.data.wfs.WFSFeatureReader;
import org.geotools.data.wfs.WFSFeatureStore;
import org.geotools.feature.Feature;
import org.geotools.feature.FeatureFactory;
import org.w3c.dom.Document;

import com.iver.cit.gvsig.fmap.core.DefaultFeature;
import com.iver.cit.gvsig.fmap.drivers.geotools.WFSFeaturesIterator;
import com.vividsolutions.jts.util.GeometricShapeFactory;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: GMLParseTest.java,v 1.1 2006/07/24 07:30:33 jorpiell Exp $
 * $Log: GMLParseTest.java,v $
 * Revision 1.1  2006/07/24 07:30:33  jorpiell
 * Se han eliminado las partes duplicadas y se est usando el parser de GML de FMAP.
 *
 *
 */
/**
 * @author Jorge Piera Llodr (piera_jor@gva.es)
 */
public class GMLParseTest {
	private static String sfile = new String("E:\\cities.gml");
	
	public static void main(String[] args) throws Exception {
		parseFile(sfile);
	}
	
	public static void parseFile(String sfile) throws Exception{
		InputStream is = new FileInputStream(new File(sfile));		
			
		FeatureReader r = WFSFeatureReader.getFeatureReader(is, 
				10000,
				10000,
				null,
				null);		
				
		int i=0;
		
		try{
		while (r.hasNext()){
			r.next();
			System.out.println(i++);
			
		}
		}catch (Exception e){
			e.printStackTrace();
		}
		System.out.println("NUM FEATURES: " + i);
		
		//URL url = new File(sfile).toURL();
		//GMLDataStore dataStore = new GMLDataStore(new File(sfile).toURI());//(GMLDataStore) new GMLDataStoreFactory().createDataStore(url);
		//FeatureReader reader = dataStore.getFeatureReader(new DefaultQuery("places"),Transaction.AUTO_COMMIT);
//		
				
//		int i = 0;
//		while (reader.hasNext()){
//			i++;
//		}
//		System.out.println("Numero de features: " + i);
		
//		SchemaParser parser = new SchemaParser();
//		GMLSchema schema = null;
//		
//		if (parser.parseDescribeFeatureType(new File(fileSchema)) == true){
//			schema = parser.getSchema();
//			schema.setName("places");
//		}
		
//		Feature f = new DefaultFeature(new Geom);
//		
//		DocumentBuilderFactory factory = factory = DocumentBuilderFactory.newInstance();
//		Document doc = factory.newDocumentBuilder().parse(sfile);
//		GMLFeature feature = GMLFactory.createGMLFeature(doc,GMLConverter.featureTypefromGeotoolsToGvSIG(schema));
////		
		
//    	FeatureReader reader = GMLConverter.getFeatureReader(new File(sfile),schema);
////		
//		int i = 0;
//		while (reader.hasNext()){
//			i++;
//			System.out.println(i);
//		}
//		System.out.println("Numero de features: " + i);
//		
		//FeatureSource source = dataStore.getFeatureSource("places");	
		
//		Query query = new DefaultQuery("places");
//		dataStore.getFeatureReader(query,Transaction.AUTO_COMMIT);
	}	
}
